local ffi = require 'ffi'
ffi.cdef [[
typedef unsigned long uLong;
typedef unsigned int uInt;
typedef unsigned char Bytef;

uLong adler32 (uLong adler, const Bytef *buf, uInt len);
uLong crc32 (uLong crc, const Bytef *buf, uInt len);
]]
local zlib = ffi.load("z")
local msg = "Hello World!\n"
print(zlib.crc32(0, msg, #msg))   --> 2098519517
print(zlib.adler32(1, msg, #msg)) --> 546374728
